#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>

GLfloat lightPosition[] = {5.0, 20.0, 20.0};
GLfloat lightSet[] = {1.0, 1.0, 1.0};

GLfloat MatChromeDif[] = {0.4, 0.4, 0,4, 1.0};
GLfloat MatChromeAmb[] = {0.25, 0.25, 0.25, 1.0};
GLfloat MatChromeSpe[] = {0.774597, 0.774597, 0.774597, 1.0};
GLfloat MatChrome = 76.8;

GLfloat MatBrassDif[] = {0.780392, 0.568627, 0.113725, 1.0};
GLfloat MatBrassAmb[] = {0.329412, 0.223529, 0.027451, 1.0};
GLfloat MatBrassSpe[] = {0.992157, 0.941176, 0.807843, 1.0};
GLfloat MatBrass = 27.8974;

GLfloat MatPewterDif[] = {0.427451, 0.470588, 0.541176, 1.0};
GLfloat MatPewterAmb[] = {0.105882, 0.058824, 0.113725, 1.0};
GLfloat MatPewterSpe[] = {0.333333, 0.333333, 0.521569, 1.0};
GLfloat MatPewter = 9.84615;

GLint angle = 0;

GLdouble degree = 0.01745329251994329576923;
GLdouble spherex,spherez, t = 0;

GLint troj = 0;
GLdouble trix = 0, triz = 2.5;
GLint triAngle = 0;

GLfloat eyy[] = {10, 3, 0};

bool sledujTor = false;
GLdouble tx, tz, fi;

void display(void) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_ACCUM_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);				
	glLoadIdentity();
	//gluLookAt(0,20,1,0,0,0,0,1,0);	

	if(sledujTor) {
		fi = 3.1415926535897932384614 * angle / 180;
		tx = 10*cos(fi);
		tz = -10*sin(fi);
		fi += degree;
		gluLookAt(tx,0,tz,0,0,0,0,1,0);
	}else {
		gluLookAt(0,20,1,0,0,0,0,1,0);
	}
	
	//nastaveni svetla	
	glLightfv(GL_LIGHT1, GL_POSITION, lightPosition);
	glLightfv(GL_LIGHT1, GL_AMBIENT, lightSet);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightSet);	
	glLightfv(GL_LIGHT1, GL_SPECULAR, lightSet);
	
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MatChromeDif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MatChromeAmb);	
	glMaterialfv(GL_FRONT, GL_SPECULAR, MatChromeAmb);
	glMaterialf(GL_FRONT, GL_SHININESS, MatChrome);		
	switch(troj) {
		case 0: {			
			if(trix <= 4.3) {
				trix += 0.1;				
			}else {
				if(triAngle < 120) {
					triAngle++;
				}else {
					troj = 1;
				}
			}
			break;
		}
		case 1: {
			if(trix > 0) {
				trix -= 0.1;
				triz -= 0.1;				
			}else {
				if(triAngle < 240) {
					triAngle++;
				}else {
					troj = 2;
				}
			}			
			break;
		}
		case 2: {
			if(trix > -4.3) {
				trix -= 0.1;
				triz += 0.1;				
			}else {
				if(triAngle < 360) {
					triAngle++;
				}else {
					triAngle = 0;
					troj = 0;
				}
			}			
			break;	
		}
	}	
	glPushMatrix();
	glTranslatef(trix, 3, triz);
	glRotatef(triAngle, 0, 1, 0);
	glutSolidTeapot(1);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, MatBrassDif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MatBrassAmb);	
	glMaterialfv(GL_FRONT, GL_SPECULAR, MatBrassAmb);
	glMaterialf(GL_FRONT, GL_SHININESS, MatBrass);	

	spherex = 7 * pow(cos(t),3);
	spherez = 7 * pow(sin(t),3);
	t += degree;
	if(t >= 6.2831853071795864769228) {
		t = 0;
	}
	glPushMatrix();
	glTranslatef(0,-3,0);
	glTranslatef(spherex,0,spherez);
	glutSolidSphere(1, 36, 36);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, MatPewterDif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MatPewterAmb);	
	glMaterialfv(GL_FRONT, GL_SPECULAR, MatPewterAmb);
	glMaterialf(GL_FRONT, GL_SHININESS, MatPewter);	
	
	glPushMatrix();
	glRotatef(angle++, 0, 1, 0);
	glTranslatef(4,0,0);	
	glRotatef(45, 1, 0, 0);
	glutSolidTorus(0.25, 1, 36, 36);
	glPopMatrix();

	angle %= 360;

	glutSwapBuffers();			
} 


void changeSize(int w1, int h1)	{
	float ratio;
	if(h1 == 0)
		h1 = 1;
	ratio = 1.0f * w1 / h1;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    glViewport(0, 0, w1, h1	);
	gluPerspective(45, ratio, 1, 1000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();	
} 

void menuProcess(int option) {

	switch(option) {
		case 0: {
			sledujTor = false;
			break;
		}
		case 1: {
			sledujTor = true;			
			break;
		}
		case 2: {
			exit(0);
		}
	}
}

// vytvori menu
void makeMenu(void) {	

	glutCreateMenu(menuProcess);
	glutAddMenuEntry("Pohyb tles", 0);	
	glutAddMenuEntry("Sleduj torus", 1);
	glutAddMenuEntry("Exit", 2);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

void keyboard(unsigned char key, int x, int y) {
	switch(key) {
	case 27:
		exit(0);
	}
}


void init() {

	glMatrixMode(GL_PROJECTION);
	gluPerspective(45, 4/3, 1, 1000);	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 5, 20, 0, 0, 0, 0.0, 1.0, 0.0);

	glClearColor(0.0, 0.0, 0.0, 1.0);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT1);
	
	makeMenu();	
}



int main(int argc, char *argv[])
{
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);	
	glutInit(&argc, argv);
	
	glutInitWindowPosition(0,0);
	glutInitWindowSize(800,600);				
	glClearColor(0.0, 0.0, 0.0, 1.0);	
	glutCreateWindow("PB009");			

	init();	

	glutKeyboardFunc(keyboard);
	glutIdleFunc(display);
	glutDisplayFunc(display);
	glutReshapeFunc(changeSize);	

	glutMainLoop();	
	
	return 0;
}
